# Namespace: map_module

## map_module

Módulo mapa, utilizado para crear y gestionar el mapa en nicho ecológico y comunidad ecológica.

Source:
  - map_module.js, line 2

### Methods

#### (private, static) ._addControls()

Agrega control personalizado para la eliminación de puntos.

Source:
  - map_module.js, line 708

#### (private, static) ._addPointLayer()

Éste método realiza la carga de una capa en el mapa con las ocurrencias de la especie objetivo seleccionada en el análisis de nicho ecológico.

Source:
  - map_module.js, line 934

#### (private, static) ._cargaPaletaColor(a, n, balanced)

Éste método secciona el array de celdas y score realcionado en deciles

##### Parameters:

Name | Type | Description
--- | --- | ---
`a` | array | Array de celdas y score relacionado
`n` | integer | Núemro de particiones
`balanced` | boolean | Bandera para indicar si las particiones serán balanceadas

Source:
  - map_module.js, line 1596

#### (private, static) ._cargaPaletaColor(arg_1, arg_2, first_pos, mapa_prob)

Éste método obtiene los límites de las particiones realizadas por deciles que serán utilizadas para la asignación de color a las celdas.

##### Parameters:

Name | Type | Description
--- | --- | ---
`arg_1` | array | Array de valores positivos o negativos resultado del análisis de nicho ecológico.
`arg_2` | array | Array de valores positivos o negativos resultado del análisis de nicho ecológico.
`first_pos` | boolean | Bandera para indicar que array de valores esta en el primer parámetro de la función, true para positivos y false para negativos
`mapa_prob` | boolean | Bandera para indicar si el análisis de nicho ecológico se hizo con probabilidad

Source:
  - map_module.js, line 1408

#### (private, static) ._cargaPaletaColor(mapa_prob)

Éste método obtiene la escala de colores para la coloración del mapa

##### Parameters:

Name | Type | Description
--- | --- | ---
`mapa_prob` | boolean | Bandera para saber si el mapa despliega el color con probalidad por celda

Source:
  - map_module.js, line 1265

#### (private, static) ._deletePoints()

Éste método controla la eliminación de puntos de una capa de ocurrencias de la especie objetivo seleccionada en el análisis de nicho ecológico.

Source:
  - map_module.js, line 969

#### (private, static) ._drawingOnCanvas(canvasOverlay, params)

Crea y configura la malla embebida en la capa del mapa.

##### Parameters:

Name | Type | Description
--- | --- | ---
`canvasOverlay` | object | Objecto canvas donde esta contenida la malla
`params` | json | Json con los parámetros para configurar la malla

Source:
  - map_module.js, line 528

#### (private, static) ._fillSpeciesData(occ, occ_cell)

Éste método despliega la información de la especie seleccionada en el análisis de nicho ecológico.

##### Parameters:

Name | Type | Description
--- | --- | ---
`occ` | integer | Número de ocurrencias de la especie
`occ_cell` | integer | Número de celdas ocupadas por la especie

Source:
  - map_module.js, line 906

#### (private, static) ._getMessagePopup(feature)

Éste método despliega el mensaje informativo de la ocurrencia de la especie seleccionada en el análisis de nicho ecológico.

##### Parameters:

Name | Type | Description
--- | --- | ---
`feature` | object | Objeto tipo punto de la ocucurrencia seleccionada para el análisis de nicho ecológico

Source:
  - map_module.js, line 1062

#### (static) ._loadD3GridMX()

Realiza la petición de la malla al servidor

Source:
  - map_module.js, line 386

#### (private, static) ._mapConfigure(language_module, tipo_modulo, histogram_module)

Éste método realiza la creación del objeto mapa, configura el módulo de lenguaje, genera lso controles para interactur con el mapa y realiza petición de la malla.

##### Parameters:

Name | Type | Description
--- | --- | ---
`language_module` | object | Módulo lenguaje
`tipo_modulo` | integer | Tipo de módulo donde será asignado el mapa, nicho o comunidad ecológica
`histogram_module` | object | Módulo histograma

Source:
  - map_module.js, line 289

#### (static) .addMapControl(control)

Agrega controles a la instancia del mapa.

##### Parameters:

Name | Type | Description
--- | --- | ---
`control` | object | Objeto tipo control

Source:
  - map_module.js, line 653

#### (static) .addMapLayer(layer, name)

Agrega capas al controlador de capas.

##### Parameters:

Name | Type | Description
--- | --- | ---
`layer` | object | Capa para ser agregada al controlador de capas
`name` | String | Nombre de la capa

Source:
  - map_module.js, line 614

#### (static) .busca_especie(cfiltros)

Éste método obtiene las ocurrencias de una especie seleccionada en el análisis de nicho ecológico.

##### Parameters:

Name | Type | Description
--- | --- | ---
`cfiltros` | boolean | Bandera para saber si serán considerados los filtros temporales

Source:
  - map_module.js, line 782

#### (static) .busca_especie_filtros(rango, sfecha)

Busca las ocurrencias de una especie asignando filtros por fecha.

##### Parameters:

Name | Type | Description
--- | --- | ---
`rango` | array | Array con el rango de fechas
`sfecha` | boolean | Bandera para saber si serán considerados los registros sin fecha

Source:
  - map_module.js, line 758

#### (static) .colorizeFeatures(grid_map_color, first)

Asigna color y borde a las celdas que componen la malla en nicho ecológico.

##### Parameters:

Name | Type | Description
--- | --- | ---
`grid_map_color` | json | GeoJson de la malla
`first` | boolean | Bandera para conocer si es la primera carga de la malla

Source:
  - map_module.js, line 446

#### (static) .colorizeFeaturesNet(arg_gridid, arg_count, link_color_brewer)

Asigna color y borde a las celdas que componen la malla en comunidad ecológica.

##### Parameters:

Name | Type | Description
--- | --- | ---
`arg_gridid` | array | Array con los ids de la malla
`arg_count` | type | Número de ocurrencias por celda contenidas en la malla
`link_color_brewer` | function | Función que asigna color a cada celda de la malla

Source:
  - map_module.js, line 485

#### (static) .createDecilColor(json, mapa_prob)

Éste método realiza la partición en deciles y la asignación de escala de colores de un conjunto de celdas con valores de score asignado.

##### Parameters:

Name | Type | Description
--- | --- | ---
`json` | json | Json con el conjunto de celdas y score asignado resultado del análisis de nicho ecológico
`mapa_prob` | boolean | Bandera para saber si el mapa despliega el color con probalidad por celda

Source:
  - map_module.js, line 1095

#### (static) .get_allowedCells()

Método getter de las celdas consideradas para el análisis de nicho o comunidad ecológica.

Source:
  - map_module.js, line 216

#### (static) .get_allowedPoints()

Método getter de las ocurrencias de la especie objetivo consideradas para el análisis de nicho o comunidad ecológica.

Source:
  - map_module.js, line 166

#### (static) .get_allowedPoints()

Método getter de las ocurrencias descartadas de la especie objetivo para el análisis de nicho o comunidad ecológica.

Source:
  - map_module.js, line 179

#### (static) .get_discardedCellFilter()

Método getter de las celdas decartadas para el análisis de nicho o comunidad ecológica.

Source:
  - map_module.js, line 204

#### (static) .get_discardedPointsFilter()

Método getter de las ocurrencias descartadas por filtros de la especie objetivo para el análisis de nicho o comunidad ecológica.

Source:
  - map_module.js, line 192

#### (static) .get_layerControl()

Método getter del controlador de capas.

Source:
  - map_module.js, line 126

#### (static) .get_specieTarget()

Método getter de la especie objetivo seleccionada.

Source:
  - map_module.js, line 138

#### (static) .getMap()

Método getter del mapa utilizado en el análisis de nicho o comunidad ecológica.

Source:
  - map_module.js, line 229

#### (static) .removeMapControl(control)

Elimina controles a la instancia del mapa.

##### Parameters:

Name | Type | Description
--- | --- | ---
`control` | object | Objeto tipo control

Source:
  - map_module.js, line 669

#### (static) .removeMapLayer(layer, name)

Elimina capas del controlador de capas.

##### Parameters:

Name | Type | Description
--- | --- | ---
`layer` | object | Capa para ser agregada al controlador de capas
`name` | String | Nombre de la capa

Source:
  - map_module.js, line 634

#### (static) .set_specieTarget(specie_target)

Método setter de la especie objetivo seleccionada.

##### Parameters:

Name | Type | Description
--- | --- | ---
`specie_target` | json | Json con la información de la especie objetivo seleccionada

Source:
  - map_module.js, line 151

#### (static) .setDisplayModule(display_module)

Método setter del controlador de nicho o comunidad ecológica.

##### Parameters:

Name | Type | Description
--- | --- | ---
`display_module` | object | Referencia al controlador de nicho o comunidad ecológica

Source:
  - map_module.js, line 242

#### (static) .showPopUp(htmltable, latlng)

Despliega la tabla con los elementos que contiene la celda seleccioanda.

##### Parameters:

Name | Type | Description
--- | --- | ---
`htmltable` | String | Tabla estructurada en formato HTML con la información por celda del análisis de nicho ecológico
`latlng` | object | Objeto que contiene las coordenadas donde fue seleccionada la celda

Source:
  - map_module.js, line 688

#### (static) .startMap(language_module, tipo_modulo, histogram_module)

Éste método inicializa la configuración del mapa

##### Parameters:

Name | Type | Description
--- | --- | ---
`language_module` | array | Módulo lenguaje
`tipo_modulo` | integer | Tipo de módulo donde será creado el mapa, nicho o comunidad ecológica
`histogram_module` | boolean | Módulo histograma

Source:
  - map_module.js, line 1664